+++
title = "User manual"
template = "book.html"
page_template = "book.html"

[extra]
book = true
js = ["video-embed.js"]
+++

<br />

![Graphite logo](https://static.graphite.rs/logos/graphite-logotype-color.svg)

Welcome to the Graphite user manual. Get ready to learn how the software can help bring your 2D creative ideas to life.

You may choose to read this sequentially and learn from the structured introduction and sample projects. Or you may jump to chapters of interest that also serve as quick reference.

## More chapters coming soon

Additional manual chapters are being added over time. Check back often!

## Jump right in

<!-- If you're eager to skip the reading, head straight to the [hands-on quickstart video](./introduction) in the next chapter for a beginner project walkthrough you can follow along with. -->

The fastest way to get started is to watch and follow along with the steps in the hands-on quickstart video:

<div class="video-embed aspect-16x9">
	<img data-video-embed="7gjUhl_3X10" src="https://static.graphite.rs/content/learn/introduction/tutorial-1-vector-art-quickstart-youtube.avif" onerror="this.onerror = null; this.src = this.src.replace('.avif', '.png')" alt="Graphite Tutorial 1 - Hands-On Quickstart" />
</div>

## Need help?

If you're ever stuck or confused, ask your questions in the `#🧭user-help` channel of the [Graphite Discord server](https://discord.graphite.rs) or post a thread in the [discussion board](https://github.com/GraphiteEditor/Graphite/discussions) on GitHub.
