+++
title = "Graphite logo"

[extra]
css = ["logo.css"]
+++

<section class="reading-material">
<div class="section">

# Graphite logo

<article>

Graphite's logo is represented by the end of a pencil, drawing a sketch mark, that is protruding from a hexagon.

The pencil and its streak, composed of the substance graphite, signifies the software's name and its role as a drawing tool and versatile art medium.

The hexagon represents one unit in the lattice grid chemical structure of graphene. The angled line is a double bond. This references the Graphene node engine which powers the Graphite editor. The lattice grid also resembles the nodes and edges of a mathematical graph, referencing the node graph that is fundamental to both the Graphene engine and Graphite editor. The first syllable of both names also alludes to that central node graph.

## Usage policy

The Graphite logo is made available for community use. While the software is free and open source, the brand identity is more restrictive. Please be respectful of the Graphite brand by reviewing the usage policy.

Please be advised that the logo is not part of the software's Apache 2.0 license. Users of the logo must adhere to the usage policy:

1. Do not use the Graphite logo as your own. It should not be used as your primary, or most visually prominent, branding. Your usage should not imply that it's a part of the official Graphite project, nor that it's endorsed or affiliated.
2. Only use the logo when talking about, describing, referencing, or crediting the official Graphite project or software. If used as a hyperlink, it should point only to <https://graphite.rs>.
3. Do not modify the logo. The solid-colored version may only be recolored with another solid color if doing so is necessary for visual consistency when presented alongside other logos of the same color. Sufficient blank space should be preserved around the logo so it does not compete with impinging design elements.
4. Commercial use of the logo (for example, merchandise sales) is not allowed without permission.

If in doubt, please <a href="/contact">get in touch</a> by email to request clarification or permission.

## Download

Download the complete [logo kit](https://static.graphite.rs/logos/graphite-logo-kit.zip) or a specific version in PNG or SVG format below.

</article>

</div>
</section>

<br />

<section class="feature-box logo-view color">
	<div class="box">
		<div>
			<img src="https://static.graphite.rs/logos/graphite-logotype-color.svg" height="160" />
			<span>Graphite Logotype (Color)</span>
			<a href="https://static.graphite.rs/logos/graphite-logotype-color.svg" download>Download (SVG)</a>
			<a href="https://static.graphite.rs/logos/graphite-logotype-color-240x937.png" download>Download (PNG 240x937)</a>
			<a href="https://static.graphite.rs/logos/graphite-logotype-color-480x1874.png" download>Download (PNG 480x1874)</a>
		</div>
		<div>
			<img src="https://static.graphite.rs/logos/graphite-logo-color.svg" width="160" height="160" />
			<span>Graphite Icon (Color)</span>
			<a href="https://static.graphite.rs/logos/graphite-logo-color.svg" download>Download (SVG)</a>
			<a href="https://static.graphite.rs/logos/graphite-logo-color-240x240.png" download>Download (PNG 240x240)</a>
			<a href="https://static.graphite.rs/logos/graphite-logo-color-480x480.png" download>Download (PNG 480x480)</a>
		</div>
	</div>
</section>

<section class="feature-box logo-view light">
	<div class="box">
		<div>
			<img src="https://static.graphite.rs/logos/graphite-logotype-solid.svg" height="160" />
			<span>Graphite Logotype (Solid)</span>
			<a href="https://static.graphite.rs/logos/graphite-logotype-solid.svg" download>Download (SVG)</a>
			<a href="https://static.graphite.rs/logos/graphite-logotype-solid-240x937.png" download>Download (PNG 240x937)</a>
			<a href="https://static.graphite.rs/logos/graphite-logotype-solid-480x1874.png" download>Download (PNG 480x1874)</a>
		</div>
		<div>
			<img src="https://static.graphite.rs/logos/graphite-logo-solid.svg" width="160" height="160" />
			<span>Graphite Icon (Solid)</span>
			<a href="https://static.graphite.rs/logos/graphite-logo-solid.svg" download>Download (SVG)</a>
			<a href="https://static.graphite.rs/logos/graphite-logo-solid-240x240.png" download>Download (PNG 240x240)</a>
			<a href="https://static.graphite.rs/logos/graphite-logo-solid-480x480.png" download>Download (PNG 480x480)</a>
		</div>
	</div>
</section>

<section class="feature-box logo-view dark">
	<div class="box">
		<div>
			<img src="https://static.graphite.rs/logos/graphite-logotype-solid-white.svg" height="160" />
			<span>Graphite Logotype (Solid, White)</span>
			<a href="https://static.graphite.rs/logos/graphite-logotype-solid-white.svg" download>Download (SVG)</a>
			<a href="https://static.graphite.rs/logos/graphite-logotype-solid-white-240x937.png" download>Download (PNG 240x937)</a>
			<a href="https://static.graphite.rs/logos/graphite-logotype-solid-white-480x1874.png" download>Download (PNG 480x1874)</a>
		</div>
		<div>
			<img src="https://static.graphite.rs/logos/graphite-logo-solid-white.svg" width="160" height="160" />
			<span>Graphite Icon (Solid, White)</span>
			<a href="https://static.graphite.rs/logos/graphite-logo-solid-white.svg" download>Download (SVG)</a>
			<a href="https://static.graphite.rs/logos/graphite-logo-solid-white-240x240.png" download>Download (PNG 240x240)</a>
			<a href="https://static.graphite.rs/logos/graphite-logo-solid-white-480x480.png" download>Download (PNG 480x480)</a>
		</div>
	</div>
</section>
